var cvi_stactive, cvi_stpiece;
var puzzle = new function ()
{
	this.init = function (divTag, picSource, options)
	{
		options = (!this.orgoptions) ? options : this.orgoptions;

		this.createImg(divTag, picSource, options, function (imageTag) { puzzle.internal(imageTag, options); });
	}

	this.internal = function (image, options)
	{
		//Default values
		this.defaultAreaborder = true;
		this.defaultAreacolor = '#e0e0e0';
		this.defaultAreaimage = false;
		this.defaultAreaopacity = 0.33;
		this.defaultBgrndcolor = '#000000';
		this.defaultBorderopacity = 0.5;
		this.defaultBorderwide = 2;
		this.defaultCompleteCallback = false;
		this.defaultCorrectPositionCallback = false;
		this.defaultFalsecolor = '#ff0000';
		this.defaultForcetouchui = false;
		this.defaultLevel = 1;
		this.defaultMatchcolor = '#00d000';
		this.defaultMixed = false;
		this.defaultShadowopacity = 0.75;
		this.defaultSnap = 8;
		this.defaultSpace = 40;

		//Internal Members
		this.myobj = image;
		this.timeFrom = null;
		this.timeTo = null;
		this.orgoptions = options;

		if (image.tagName.toUpperCase() == "IMG" && image.width >= 128 && image.height >= 128)
		{
			function uniqueID()
			{
				var v = Date.parse(new Date()) + Math.floor(Math.random() * 100000000000);
				return v.toString(16);
			}

			function hex2rgb(val)
			{
				function h2d(v)
				{
					return (Math.max(0, Math.min(parseInt(v, 16), 255)));
				}
				return h2d(val.substr(1, 2)) + ',' + h2d(val.substr(3, 2)) + ',' + h2d(val.substr(5, 2));
			}
			function dec2hex(v)
			{
				return '#' + v.toString(16) + v.toString(16) + v.toString(16);
			}
			var self, reso, imageWidth, imageHeight, defopts = { "level": puzzle.defaultLevel, "space": puzzle.defaultSpace, "snap": puzzle.defaultSnap, "mixed": puzzle.defaultMixed, "bcolor": puzzle.defaultBgrndcolor, "fcolor": puzzle.defaultFalsecolor, "mcolor": puzzle.defaultMatchcolor, "acolor": puzzle.defaultAreacolor, "aopacity": puzzle.defaultAreaopacity, "aborder": puzzle.defaultAreaborder, "aimage": puzzle.defaultAreaimage, "bopacity": puzzle.defaultBorderopacity, "bwide": puzzle.defaultBorderwide, "sopacity": puzzle.defaultShadowopacity, "forcetui": puzzle.defaultForcetouchui, "completeCallback": puzzle.defaultCompleteCallback, "correctPositioncallback": puzzle.defaultCorrectPositionCallback };
			if (options)
			{
				for (var i in defopts)
				{
					if (!options[i])
					{
						options[i] = defopts[i];
					}
				}
			}
			else
			{
				options = defopts;
			}
			imageWidth = ('iwidth' in options) ? parseInt(options.iwidth) : image.width;
			imageHeight = ('iheight' in options) ? parseInt(options.iheight) : image.height;

			self = document.createElement('canvas');
			reso = document.createElement('canvas');

			this.myobj = self;

			if ((reso && self && reso.getContext("2d") && self.getContext("2d")))
			{
				self.id = (image.id == 'undefined' || image.id == '' ? uniqueID() : image.id);
				self.alt = image.alt;
				self.title = image.title;
				self.img = image.src;
				self.className = image.className;
				self.style.cssText = image.style.cssText;
				self.style.height = imageHeight + 'px';
				self.style.width = imageWidth + 'px';
				self.height = imageHeight;
				self.width = imageWidth;
				self.sf = Math.min(1 - Math.min((typeof options['space'] === 'number' ? options['space'] : puzzle.defaultSpace) * 0.01, 0.5), 1.0);
				self.iw = parseInt(self.width * self.sf);
				self.ih = parseInt(self.height * self.sf);
				self.xo = parseInt((self.width - self.iw) / 2);
				self.yo = parseInt((self.height - self.ih) / 2);
				self.wk4 = navigator.appVersion.indexOf('WebKit') != -1 && !document.defaultCharset ? 1 : 0;
				self.ge8 = navigator.userAgent.indexOf('Gecko') > -1 && window.updateCommands && !window.external ? 1 : 0;

				reso.height = self.ih;
				reso.width = self.iw;
				reso.style.height = reso.height + 'px';
				reso.style.width = reso.width + 'px';
				if (self.wk4)
				{
					reso.id = self.id + '_buffer';
					reso.style.position = 'fixed';
					reso.style.left = '-99999px';
					reso.style.top = '0px';
					image.parentNode.appendChild(reso);
				}
				reso.ctx = reso.getContext("2d");
				reso.ctx.drawImage(image, 0, 0, self.iw, self.ih);
				image.parentNode.replaceChild(self, image);
				self.reso = reso;

				self.pc = Math.min(Math.max((typeof options['level'] === 'number' ? options['level'] : puzzle.defaultLevel), 0), 6);
				self.sv = Math.min(Math.max((typeof options['snap'] === 'number' ? options['snap'] : puzzle.defaultSnap), 1), 24);
				self.fui = (typeof options['forcetui'] === 'boolean' ? options['forcetui'] : puzzle.defaultForcetouchui);
				self.ply = true;
				self.mix = (typeof options['mixed'] === 'boolean' ? options['mixed'] : puzzle.defaultMixed);
				self.cb = (typeof options['completeCallback'] === 'function' ? options['completeCallback'] : puzzle.defaultCompleteCallback);
				self.rpcb = (typeof options['correctPositioncallback'] === 'function' ? options['correctPositioncallback'] : puzzle.defaultCorrectPositionCallback);
				self.bw = Math.min(Math.max((typeof options['bwide'] === 'number' ? options['bwide'] : puzzle.defaultBorderwide), 1.0), 6.0);
				self.bo = Math.min(Math.max((typeof options['bopacity'] === 'number' ? options['bopacity'] : puzzle.defaultBorderopacity), 0.0), 1.0);
				self.ao = Math.min(Math.max((typeof options['aopacity'] === 'number' ? options['aopacity'] : puzzle.defaultAreaopacity), 0.0), 1.0);
				self.so = Math.min(Math.max((typeof options['sopacity'] === 'number' ? options['sopacity'] : puzzle.defaultShadowopacity), 0.0), 1.0);
				self.hxs = dec2hex(parseInt((1 - self.so) * 255));
				self.lsd = 300;
				self.nhc = false;
				self.ab = (typeof options['aborder'] === 'boolean' ? options['aborder'] : puzzle.defaultAreaborder);
				self.ai = (typeof options['aimage'] === 'boolean' ? options['aimage'] : puzzle.defaultAreaimage);
				self.bcl = (typeof options['bcolor'] === 'string' ? options['bcolor'].match(/^#[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]$/i) ? options['bcolor'] : puzzle.defaultBgrndcolor : puzzle.defaultBgrndcolor);
				self.fcl = (typeof options['fcolor'] === 'string' ? options['fcolor'].match(/^#[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]$/i) ? options['fcolor'] : puzzle.defaultFalsecolor : puzzle.defaultFalsecolor);
				self.acl = (typeof options['acolor'] === 'string' ? options['acolor'].match(/^#[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]$/i) ? options['acolor'] : puzzle.defaultAreacolor : puzzle.defaultAreacolor);
				self.mcl = (typeof options['mcolor'] === 'string' ? options['mcolor'].match(/^#[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]$/i) ? options['mcolor'] : puzzle.defaultMatchcolor : puzzle.defaultMatchcolor);
				self.aos = navigator.userAgent.match(/android/i);
				self.ios = navigator.platform.match(/iPad|iPhone|iPod/i);
				self.stg = typeof (document.ontouchstart) != "undefined" ? true : false;
				self.tod = self.stg && (self.ios || self.aos || self.fui) ? true : false;
				self.tmp = Math.min(self.iw, self.ih) / (self.ply ? 2 : 1);
				self.sz = [Math.min(self.tmp, 160), Math.min(self.tmp, 128), Math.min(self.tmp, 104), Math.min(self.tmp, 80), Math.min(self.tmp, 64), Math.min(self.tmp, 56), Math.min(self.tmp, 48)];
				self.dbc = hex2rgb(self.bcl);
				self.dfc = hex2rgb(self.fcl);
				self.dac = hex2rgb(self.acl);
				self.dmc = hex2rgb(self.mcl);
				self.currtap = 0;
				self.lasttap = 0;
				self.style.MozUserSelect = "none";
				self.style.KhtmlUserSelect = "none";
				self.style.WebkitUserSelect = "none";
				self.unselectable = "on";
				self.offsetX = this._xoff(self);
				self.offsetY = this._yoff(self);
				self.deltaX = 0;
				self.deltaY = 0;
				self.evtX = 0;
				self.evtY = 0;
				self.dragging = false;
				self.progress = false;
				self.moved = false;
				self.cur = -1;
				puzzle._reset(self.pc, true);
				if (self.mix)
				{
					puzzle.scramble();
				}
				self.ctx = self.getContext("2d");
				self.ctx.shadowOffsetX = 4;
				self.ctx.shadowOffsetY = 4;
				self.ctx.shadowBlur = 6;
				self.ctx.shadowColor = "rgba(0,0,0,0)";
				if (self.tod)
				{
					self.ontouchstart = this._catchTouch;
				}
				else
				{
					self.onmousedown = this._isPressed;
					self.onmousemove = this._isDragged;
					self.onmouseup = this._isReleased;
					//self.ondblclick = this._isDblclicked;
					self.onmouseout = this._isReleased;
					self.onclick = this._isDblclicked;
					self.oncontextmenu = function ()
					{
						return false;
					};

					self.onmouseover = this._catchOver;
					self.addEventListener('mouseout', this._catchOut, false);
				}

				puzzle._paint();
				return true;
			}
			return false;
		}
		return false;
	}
	this.createImg = function (divTag, picSource, options, onImageLoad)
	{
		if (document.getElementById('myimage') != null)
		{
			divTag.removeChild(document.getElementById('myimage'));
		}

		var imageTag = document.createElement('img');
		imageTag.id = "myimage";
		imageTag.onload = function () { onImageLoad(imageTag); };

		var pictureAttr = { "width": "", "height": "" };
		if (options)
		{
			for (var i in pictureAttr)
			{
				if (!!options[i])
				{
					imageTag.setAttribute(i, options[i]);
				}
			}
		}

		imageTag.src = picSource;

		divTag.appendChild(imageTag);
	}
	this.remove = function ()
	{
		if (!this.myobj.progress && (this.myobj.getContext || this.myobj.tagName.toUpperCase() == "VAR"))
		{
			var obj = this.myobj.parentNode;
			var img = document.createElement('img');
			if (this.myobj.wk4)
			{
				obj.removeChild(document.getElementById(this.myobj.id + '_buffer'));
			}
			img.id = this.myobj.id;
			img.alt = this.myobj.alt;
			img.title = this.myobj.title;
			img.src = this.myobj.img;
			img.className = this.myobj.className;
			img.style.cssText = this.myobj.style.cssText;
			img.style.height = this.myobj.height + 'px';
			img.style.width = this.myobj.width + 'px';
			obj.replaceChild(img, this.myobj);
		}
	}
	this.scramble = function ()
	{
		if (!this.myobj.progress && (this.myobj.getContext || this.myobj.tagName.toUpperCase() == "VAR"))
		{
			function R(v)
			{
				return Math.floor(Math.random() * v);
			}
			var ele, i, j, l, r, a = 90;
			this.myobj.progress = true;
			if (this.myobj.vml)
			{
				this.myobj.style.cursor = 'wait';
				for (i = 0; i < this.myobj.obj.length; i++)
				{
					ele = document.getElementById(this.myobj.id + '|obj_' + i);
					this.myobj.obj[i].x = R(this.myobj.width - this.myobj.obj[i].w);
					this.myobj.obj[i].y = R(this.myobj.height - this.myobj.obj[i].h);
					ele.style.left = this.myobj.obj[i].x + 'px';
					ele.style.top = this.myobj.obj[i].y + 'px';
				}
			}
			else
			{
				this.myobj.style.cursor = 'progress';
				for (i = 0; i < this.myobj.obj.length; i++)
				{
					this.myobj.obj[i].x = R(this.myobj.width - this.myobj.obj[i].w);
					this.myobj.obj[i].y = R(this.myobj.height - this.myobj.obj[i].h);
					l = R(4);
					for (j = 0; j < l; j++)
					{
						r = this.myobj.obj[i].a;
						this.myobj.obj[i] = puzzle._rotate(this.myobj.obj[i], this.myobj.width, this.myobj.height, a, this.myobj.ply, this.myobj.lsd, this.myobj.nhc);
						this.myobj.obj[i].a = r < (360 - a) ? this.myobj.obj[i].a + a : 0;
					}
				}

				puzzle._paint();
			}
			for (i = 0; i < this.myobj.obj.length; i++)
			{
				p = this.myobj.obj[i];
				if ((p.f && p.m && p.a == 180) || (!p.f && !p.m && p.a == 0))
				{
					if (p.x != (p.ox + this.myobj.xo) || p.x != (p.ox + this.myobj.xo) || p.y != (p.oy + this.myobj.yo) || p.y != (p.oy + this.myobj.yo))
					{
						this.myobj.obj[i].z = true;
					}
					else
					{
						this.myobj.obj[i].z = false;
					}
				}
				else
				{
					this.myobj.obj[i].z = false;
				}
			}
			this.myobj.style.cursor = 'auto';
			this.myobj.progress = false;
			this.timeFrom = new Date();
			return true;
		}
		else
		{
			return false;
		}
	}
	this.solve = function ()
	{
		var myself = this.myobj;

		if (!this.myobj.progress && (this.myobj.getContext || this.myobj.tagName.toUpperCase() == "VAR"))
		{
			var i, j, l, p, r, odd = 0, m = 4, a = 90, n = puzzle._isSolved();
			if (!n)
			{
				if (this.myobj.vml)
				{
					for (i = 0; i < this.myobj.obj.length; i++)
					{
						odd = document.getElementById(this.myobj.id + '|obj_' + i);
						this.myobj.obj[i].f = 0;
						this.myobj.obj[i].a = 0;
						this.myobj.obj[i].w = this.myobj.obj[i].ow;
						this.myobj.obj[i].h = this.myobj.obj[i].oh;
						odd.firstChild.opacity = 1;
						odd.style.filter = "progid:DXImageTransform.Microsoft.BasicImage(rotation=0, mirror=0)";
					}
				}
				else
				{
					for (i = 0; i < this.myobj.obj.length; i++)
					{
						odd = this.myobj.obj[i].a == 90 || this.myobj.obj[i].a == 270 ? 1 : 0;
						if ((this.myobj.obj[i].m && odd) || this.myobj.obj[i].f)
						{
							if (this.myobj.ply)
							{
								this.myobj.obj[i].l = puzzle._shade(this.myobj.obj[i].t, this.myobj.lsd, this.myobj.nhc);
							}
							if (odd)
							{
								this.myobj.obj[i].m = this.myobj.obj[i].m ? 0 : 1;
							}
							else
							{
								this.myobj.obj[i].f = this.myobj.obj[i].f ? 0 : 1;
							}
						}
						if ((this.myobj.obj[i].f && odd) || this.myobj.obj[i].m)
						{
							if (this.myobj.ply)
							{
								this.myobj.obj[i].l = puzzle._shade(this.myobj.obj[i].t, this.myobj.lsd, this.myobj.nhc);
							}
							if (odd)
							{
								this.myobj.obj[i].f = this.myobj.obj[i].f ? 0 : 1;
							}
							else
							{
								this.myobj.obj[i].m = this.myobj.obj[i].m ? 0 : 1;
							}
						}
						if ((this.myobj.obj[i].m && odd) || this.myobj.obj[i].f)
						{
							if (this.myobj.ply)
							{
								this.myobj.obj[i].l = puzzle._shade(this.myobj.obj[i].t, this.myobj.lsd, this.myobj.nhc);
							}
							if (odd)
							{
								this.myobj.obj[i].m = this.myobj.obj[i].m ? 0 : 1;
							}
							else
							{
								this.myobj.obj[i].f = this.myobj.obj[i].f ? 0 : 1;
							}
						}
						if ((this.myobj.obj[i].f && odd) || this.myobj.obj[i].m)
						{
							if (this.myobj.ply)
							{
								this.myobj.obj[i].l = puzzle._shade(this.myobj.obj[i].t, this.myobj.lsd, this.myobj.nhc);
							}
							if (odd)
							{
								this.myobj.obj[i].f = this.myobj.obj[i].f ? 0 : 1;
							}
							else
							{
								this.myobj.obj[i].m = this.myobj.obj[i].m ? 0 : 1;
							}
						}
						n = this.myobj.obj[i].a / 90;
						l = n > 0 ? m - n : 0;
						for (j = 0; j < l; j++)
						{
							r = this.myobj.obj[i].a;
							this.myobj.obj[i] = puzzle._rotate(this.myobj.obj[i], this.myobj.width, this.myobj.height, a, this.myobj.ply, this.myobj.lsd, this.myobj.nhc);
							this.myobj.obj[i].a = r < (360 - a) ? this.myobj.obj[i].a + a : 0;
						}
					}

					if (this.myobj.timer)
					{
						window.clearInterval(this.myobj.timer);
					}
					this.myobj.progress = true;
					this.myobj.style.cursor = 'progress';
					var q = 0, c = 0, t = 20, k = 1 / t, sx = [], sy = [], ex = [], ey = [];
					for (i = 0; i < this.myobj.obj.length; i++)
					{
						sx[i] = this.myobj.obj[i].x;
						sy[i] = this.myobj.obj[i].y;
						ex[i] = this.myobj.obj[i].ox + this.myobj.xo;
						ey[i] = this.myobj.obj[i].oy + this.myobj.yo;
					}

					this.myobj.timer = window.setInterval(function ()
					{
						q = ((-Math.cos((k * c) * Math.PI) / 2) + 0.5) || 0;
						for (i = 0; i < myself.obj.length; i++)
						{
							myself.obj[i].x = Math.ceil(sx[i] + (q * (ex[i] - sx[i])));
							myself.obj[i].y = Math.ceil(sy[i] + (q * (ey[i] - sy[i])));
						}
						c++;
						puzzle._paint();
						if (c > t)
						{
							window.clearInterval(myself.timer);
							for (i = 0; i < myself.obj.length; i++)
							{
								myself.obj[i].x = myself.obj[i].ox + myself.xo;
								myself.obj[i].y = myself.obj[i].oy + myself.yo;
								myself.obj[i].z = true;
							}
							puzzle._paint();
							myself.style.cursor = 'auto';
							myself.progress = false;
						}
					}, 10);
				}
				return true;
			}
			else
			{
				return false;
			}
		}
		else
		{
			return false;
		}
	}
	this.changeLevel = function (level)
	{
		level = parseInt(level);

		if (!isNaN(level))
		{
			this._reset(level);
		}
		else
		{
			alert("Level is not correct");
		}
	}
	this.changeImage = function (imageSource)
	{
		//alert(this.myobj.tagName)
		//alert(this.myobj.parentNode)
		puzzle.init(this.myobj.parentNode, imageSource);
	}
	this._reset = function (pres, option)
	{
		if (!this.myobj.progress && (this.myobj.getContext || this.myobj.tagName.toUpperCase() == "VAR"))
		{
			this.myobj.progress = true;
			this.myobj.style.cursor = this.myobj.vml ? 'wait' : 'progress';
			this.myobj.pc = Math.min(Math.max((typeof pres === 'number' ? pres : this.myobj.pc), 0), 6);
			var i, j, a, t, m, xo, yo, wp, wf, hp, hf, tw, th, lt, lc, lb, ct, cc, cb, rt, rc, rb, z = 0, n = this.myobj.sz[this.myobj.pc], p = {};
			t = this.myobj.iw / n;
			wp = Math.round(t);
			tw = this.myobj.iw / wp;
			wf = tw / this.myobj.iw;
			xo = wf * .25;
			t = this.myobj.ih / n;
			hp = Math.round(t);
			th = this.myobj.ih / hp;
			hf = th / this.myobj.ih;
			yo = hf * .25;
			m = [[0, 0], [0, hf], [wf, hf], [wf, 0]];
			this.myobj.obj = [];
			if (this.myobj.ply)
			{
				p.lt = [[0, 0], [0, hf], [xo, hf], [wf / 2, hf + yo], [wf - xo, hf], [wf, hf], [wf, hf - yo], [wf + xo, hf / 2], [wf, yo], [wf, 0]];
				p.ltz = puzzle._shade(p.lt, this.myobj.lsd, this.myobj.nhc);
				p.ct = [[0, 0], [0, yo], [xo, hf / 2], [0, hf - yo], [0, hf], [xo, hf], [wf / 2, hf + yo], [wf - xo, hf], [wf, hf], [wf, hf - yo], [wf + xo, hf / 2], [wf, yo], [wf, 0]];
				p.ctz = puzzle._shade(p.ct, this.myobj.lsd, this.myobj.nhc);
				p.rt = [[0, 0], [0, yo], [xo, hf / 2], [0, hf - yo], [0, hf], [xo, hf], [wf / 2, hf + yo], [wf - xo, hf], [wf, hf], [wf, 0]];
				p.rtz = puzzle._shade(p.rt, this.myobj.lsd, this.myobj.nhc);
				p.lc = [[0, 0], [0, hf], [xo, hf], [wf / 2, hf + yo], [wf - xo, hf], [wf, hf], [wf, hf - yo], [wf + xo, hf / 2], [wf, yo], [wf, 0], [wf - xo, 0], [wf / 2, yo], [xo, 0]];
				p.lcz = puzzle._shade(p.lc, this.myobj.lsd, this.myobj.nhc);
				p.cc = [[0, 0], [0, yo], [xo, hf / 2], [0, hf - yo], [0, hf], [xo, hf], [wf / 2, hf + yo], [wf - xo, hf], [wf, hf], [wf, hf - yo], [wf + xo, hf / 2], [wf, yo], [wf, 0], [wf - xo, 0], [wf / 2, yo], [xo, 0]];
				p.ccz = puzzle._shade(p.cc, this.myobj.lsd, this.myobj.nhc);
				p.rc = [[0, 0], [0, yo], [xo, hf / 2], [0, hf - yo], [0, hf], [xo, hf], [wf / 2, hf + yo], [wf - xo, hf], [wf, hf], [wf, 0], [wf - xo, 0], [wf / 2, yo], [xo, 0]];
				p.rcz = puzzle._shade(p.rc, this.myobj.lsd, this.myobj.nhc);
				p.lb = [[0, 0], [0, hf], [wf, hf], [wf, hf - yo], [wf + xo, hf / 2], [wf, yo], [wf, 0], [wf - xo, 0], [wf / 2, yo], [xo, 0]];
				p.lbz = puzzle._shade(p.lb, this.myobj.lsd, this.myobj.nhc);
				p.cb = [[0, 0], [0, yo], [xo, hf / 2], [0, hf - yo], [0, hf], [wf, hf], [wf, hf - yo], [wf + xo, hf / 2], [wf, yo], [wf, 0], [wf - xo, 0], [wf / 2, yo], [xo, 0]];
				p.cbz = puzzle._shade(p.cb, this.myobj.lsd, this.myobj.nhc);
				p.rb = [[0, 0], [0, yo], [xo, hf / 2], [0, hf - yo], [0, hf], [wf, hf], [wf, 0], [wf - xo, 0], [wf / 2, yo], [xo, 0]];
				p.rbz = puzzle._shade(p.rb, this.myobj.lsd, this.myobj.nhc);
				for (i = 0; i < hp; i++)
				{
					if (i == 0)
					{
						for (j = 0; j < wp; j++)
						{
							this.myobj.obj[z] = new Object();
							this.myobj.obj[z].a = 0;
							this.myobj.obj[z].f = 0;
							this.myobj.obj[z].m = 0;
							this.myobj.obj[z].x = (j * wf);
							this.myobj.obj[z].y = (i * hf);
							if (j == 0)
							{
								this.myobj.obj[z].s = 0;
								this.myobj.obj[z].w = wf + xo;
								this.myobj.obj[z].h = hf + yo;
								this.myobj.obj[z].t = p.lt;
								this.myobj.obj[z].l = p.ltz;
							}
							else if (j == (wp - 1))
							{
								this.myobj.obj[z].s = 1;
								this.myobj.obj[z].w = wf;
								this.myobj.obj[z].h = hf + yo;
								this.myobj.obj[z].t = p.rt;
								this.myobj.obj[z].l = p.rtz;
							}
							else
							{
								this.myobj.obj[z].s = 0;
								this.myobj.obj[z].w = wf + xo;
								this.myobj.obj[z].h = hf + yo;
								this.myobj.obj[z].t = p.ct;
								this.myobj.obj[z].l = p.ctz;
							}
							z++;
						}
					}
					else if (i == (hp - 1))
					{
						for (j = 0; j < wp; j++)
						{
							this.myobj.obj[z] = new Object();
							this.myobj.obj[z].a = 0;
							this.myobj.obj[z].f = 0;
							this.myobj.obj[z].m = 0;
							this.myobj.obj[z].x = (j * wf);
							this.myobj.obj[z].y = (i * hf);
							if (j == 0)
							{
								this.myobj.obj[z].s = 2;
								this.myobj.obj[z].w = wf + xo;
								this.myobj.obj[z].h = hf;
								this.myobj.obj[z].t = p.lb;
								this.myobj.obj[z].l = p.lbz;
							}
							else if (j == (wp - 1))
							{
								this.myobj.obj[z].s = 3;
								this.myobj.obj[z].w = wf;
								this.myobj.obj[z].h = hf;
								this.myobj.obj[z].t = p.rb;
								this.myobj.obj[z].l = p.rbz;
							}
							else
							{
								this.myobj.obj[z].s = 2;
								this.myobj.obj[z].w = wf + xo;
								this.myobj.obj[z].h = hf;
								this.myobj.obj[z].t = p.cb;
								this.myobj.obj[z].l = p.cbz;
							}
							z++;
						}
					}
					else
					{
						for (j = 0; j < wp; j++)
						{
							this.myobj.obj[z] = new Object();
							this.myobj.obj[z].a = 0;
							this.myobj.obj[z].f = 0;
							this.myobj.obj[z].m = 0;
							this.myobj.obj[z].x = (j * wf);
							this.myobj.obj[z].y = (i * hf);
							if (j == 0)
							{
								this.myobj.obj[z].s = 0;
								this.myobj.obj[z].w = wf + xo;
								this.myobj.obj[z].h = hf + yo;
								this.myobj.obj[z].t = p.lc;
								this.myobj.obj[z].l = p.lcz;
							}
							else if (j == (wp - 1))
							{
								this.myobj.obj[z].s = 1;
								this.myobj.obj[z].w = wf;
								this.myobj.obj[z].h = hf + yo;
								this.myobj.obj[z].t = p.rc;
								this.myobj.obj[z].l = p.rcz;
							}
							else
							{
								this.myobj.obj[z].s = 0;
								this.myobj.obj[z].w = wf + xo;
								this.myobj.obj[z].h = hf + yo;
								this.myobj.obj[z].t = p.cc;
								this.myobj.obj[z].l = p.ccz;
							}
							z++;
						}
					}
				}
			}
			else
			{
				for (i = 0; i < hp; i++)
				{
					for (j = 0; j < wp; j++)
					{
						this.myobj.obj[z] = new Object();
						this.myobj.obj[z].a = 0;
						this.myobj.obj[z].f = 0;
						this.myobj.obj[z].m = 0;
						this.myobj.obj[z].x = (j * wf);
						this.myobj.obj[z].y = (i * hf);
						this.myobj.obj[z].w = wf;
						this.myobj.obj[z].h = hf;
						this.myobj.obj[z].t = m;
						z++;
					}
				}
			}
			for (i = 0; i < this.myobj.obj.length; i++)
			{
				a = [];
				t = this.myobj.obj[i].t;
				for (j = 0; j < t.length; j++)
				{
					a[j] = [t[j][0] * this.myobj.iw, t[j][1] * this.myobj.ih];
				}
				this.myobj.obj[i].z = true;
				this.myobj.obj[i].t = a;
				this.myobj.obj[i].w = this.myobj.obj[i].w * this.myobj.iw;
				this.myobj.obj[i].h = this.myobj.obj[i].h * this.myobj.ih;
				this.myobj.obj[i].x = this.myobj.xo + (this.myobj.obj[i].x * this.myobj.iw);
				this.myobj.obj[i].y = this.myobj.yo + (this.myobj.obj[i].y * this.myobj.ih);
				this.myobj.obj[i].ox = this.myobj.obj[i].x - this.myobj.xo;
				this.myobj.obj[i].oy = this.myobj.obj[i].y - this.myobj.yo;
				this.myobj.obj[i].ow = this.myobj.obj[i].w;
				this.myobj.obj[i].oh = this.myobj.obj[i].h;
			}
			if (this.myobj.vml)
			{
				var ele, head, foot, fill, back, parts = '';
				head = '<v:group oncontextmenu="return false" unselectable="on" style="zoom:1;display:' + this.myobj.dpl + ';margin:0px;padding:0px;position:relative;width:' + this.myobj.width + 'px;height:' + this.myobj.height + 'px;" coordsize="' + this.myobj.width + ',' + this.myobj.height + '"><v:rect oncontextmenu="return false" unselectable="on" strokeweight="0" filled="f" stroked="f" strokeweight="0" style="zoom:1;margin:0;padding:0;display:block;position:absolute;top:0px;left:0px;width:' + this.myobj.width + 'px;height:' + this.myobj.height + 'px;"></v:rect>';
				foot = '</v:group>';
				back = '<v:rect oncontextmenu="return false" unselectable="on" filled="t" stroked="' + (!this.myobj.ai && this.myobj.ab ? 't' : 'f') + '" strokeweight="' + (!this.myobj.ai && this.myobj.ab ? 1 : 0) + '" style="zoom:1;margin:0px;padding:0px;display:block;position:absolute;top:' + this.myobj.yo + 'px;left:' + this.myobj.xo + 'px;width:' + this.myobj.iw + 'px;height:' + this.myobj.ih + 'px;filter:Alpha(opacity=' + (this.myobj.ai ? 0 : this.myobj.ao * 100) + ')"><v:fill color="' + this.myobj.acl + '" /></v:rect>';
				fill = '<v:rect oncontextmenu="return false" unselectable="on" filled="t" stroked="' + (this.myobj.ai && this.myobj.ab ? 't' : 'f') + '" strokeweight="' + (this.myobj.ai && this.myobj.ab ? 1 : 0) + '" style="zoom:1;margin:0px;padding:0px;display:block;position:absolute;top:' + this.myobj.yo + 'px;left:' + this.myobj.xo + 'px;width:' + this.myobj.iw + 'px;height:' + this.myobj.ih + 'px;filter:Alpha(opacity=' + (this.myobj.ai ? this.myobj.ao * 100 : 0) + ')"><v:fill src="' + this.myobj.img + '" type="frame" aspect="atleast" /></v:rect>';
				var l, wl, hl, k = 0, x = .5, y = .5, w = parseFloat(1 / wp), h = parseFloat(1 / hp);
				tw = wp;
				th = hp;
				if (this.myobj.ply)
				{
					wl = (this.myobj.obj[this.myobj.obj.length - 1].w / this.myobj.obj[0].w);
					hl = (this.myobj.obj[this.myobj.obj.length - 1].h / this.myobj.obj[0].h);
					if (wp <= 2)
					{
						xo = 0.5 - ((1 - wl) / 1.5);
					}
					else
					{
						xo = 0.5 - (0.5 * (1 - wl) / (wp * .5));
					}
					if (hp <= 2)
					{
						yo = 0.5 - ((1 - hl) / 1.5);
					}
					else
					{
						yo = 0.5 - (0.5 * (1 - hl) / (hp * .5));
					}
				}
				for (i = 0; i < hp; i++)
				{
					for (j = 0; j < wp; j++)
					{
						t = this.myobj.obj[k].t;
						if (this.myobj.ply)
						{
							tw = parseFloat(this.myobj.iw / this.myobj.obj[k].w);
							th = parseFloat(this.myobj.ih / this.myobj.obj[k].h);
							if (this.myobj.obj[k].s == 3)
							{
								x = .5;
								y = .5;
							}
							else
							{
								x = this.myobj.obj[k].s == 0 || this.myobj.obj[k].s == 2 ? xo : .5;
								y = this.myobj.obj[k].s == 0 || this.myobj.obj[k].s == 1 ? yo : .5;
							}
						}
						p = "m " + parseInt(t[0][0] * 100) + "," + parseInt(t[0][1] * 100);
						for (l = 1; l < t.length; l++)
						{
							p += " l " + parseInt(t[l][0] * 100) + "," + parseInt(t[l][1] * 100);
						}
						p += " x e";
						parts += '<v:shape id="' + this.myobj.id + '|obj_' + k + '" oncontextmenu="return false" unselectable="on" filled="t" stroked="t" strokeweight="1" strokecolor="' + this.myobj.bcl + '" coordorigin="0,0" coordsize="' + parseInt(this.myobj.obj[k].w * 100) + ',' + parseInt(this.myobj.obj[k].h * 100) + '" path="' + p + '" style="cursor:hand;zoom:1;margin:0px;padding:0px;display:block;position:absolute;top:' + this.myobj.obj[k].y + 'px;left:' + this.myobj.obj[k].x + 'px;width:' + this.myobj.obj[k].w + 'px;height:' + this.myobj.obj[k].h + 'px;filter:progid:DXImageTransform.Microsoft.BasicImage(rotation=0, mirror=0);"><v:fill color="' + this.myobj.bcl + '" opacity="1" src="' + this.myobj.img + '" type="frame" aspect="atleast" size="' + tw + ',' + th + '" origin="' + ((j + x - (wp * x)) * w) + ',' + ((i + y - (hp * y)) * h) + '" position="0,0" /></v:shape>';
						k++;
					}
				}
				this.myobj.innerHTML = head + back + fill + parts + foot;
				for (i = 0; i < this.myobj.obj.length; i++)
				{
					ele = document.getElementById(this.myobj.id + '|obj_' + i);
				}
			}
			if (window.opera)
			{
				for (i = 0; i < this.myobj.obj.length; i++)
				{
					this.myobj.obj[i].ow = this.myobj.obj[i].ow - 0.001;
					this.myobj.obj[i].oh = this.myobj.obj[i].oh - 0.001;
				}
			}
			if (!option)
			{
				puzzle._paint();
			}
			this.myobj.style.cursor = 'auto';
			this.myobj.progress = false;
			return true;
		}
		else
		{
			return false;
		}
	}
	this._paint = function ()
	{
		if (!this.myobj.vml && this.myobj.obj)
		{
			var p, c, k, i, j, xoff, yoff, angle, img = this.myobj.reso;
			this.myobj.ctx.clearRect(0, 0, this.myobj.width, this.myobj.height);
			this.myobj.ctx.fillStyle = "rgba(" + this.myobj.dac + "," + this.myobj.ao + ")";
			if (this.myobj.ab)
			{
				this.myobj.ctx.lineWidth = 1;
				this.myobj.ctx.strokeStyle = "rgba(0,0,0," + this.myobj.ao + ")";
				this.myobj.ctx.strokeRect(this.myobj.xo, this.myobj.yo, this.myobj.iw, this.myobj.ih);
			}
			if (this.myobj.ai)
			{
				this.myobj.ctx.globalAlpha = this.myobj.ao;
				this.myobj.ctx.drawImage(img, this.myobj.xo, this.myobj.yo, this.myobj.iw, this.myobj.ih);
				this.myobj.ctx.globalAlpha = 1.0;
			}
			else
			{
				this.myobj.ctx.fillRect(this.myobj.xo, this.myobj.yo, this.myobj.iw, this.myobj.ih);
			}
			this.myobj.ctx.save();
			for (i = 0; i < this.myobj.obj.length; i++)
			{
				p = this.myobj.obj[i];
				this.myobj.ctx.save();
				if (i == this.myobj.cur)
				{
					this.myobj.ctx.shadowColor = "rgba(0,0,0," + this.myobj.so + ")";
				}
				this.myobj.ctx.fillStyle = "rgba(" + this.myobj.dac + ",1)" || "rgba(255,255,255,1)";
				this.myobj.ctx.beginPath();
				this.myobj.ctx.moveTo(p.x + p.t[0][0], p.y + p.t[0][1]);
				for (j = 1; j < p.t.length; j++)
				{
					this.myobj.ctx.lineTo(p.x + p.t[j][0], p.y + p.t[j][1]);
				}
				this.myobj.ctx.closePath();
				this.myobj.ctx.fill();
				if (i == this.myobj.cur)
				{
					this.myobj.ctx.shadowColor = "rgba(0,0,0,0)";
				}
				if (this.myobj.wk4)
				{
					this.myobj.ctx.beginPath();
					this.myobj.ctx.moveTo(p.x + p.t[0][0], p.y + p.t[0][1]);
					for (j = 1; j < p.t.length; j++)
					{
						this.myobj.ctx.lineTo(p.x + p.t[j][0], p.y + p.t[j][1]);
					}
					this.myobj.ctx.closePath();
				}
				this.myobj.ctx.clip();
				if (this.myobj.ge8)
				{
					this.myobj.ctx.fillStyle = "rgba(0,0,0,0)";
					this.myobj.ctx.fillRect(p.x, p.y, p.w, p.h);
				}
				if (p.a != 0 || p.f || p.m)
				{
					this.myobj.ctx.save();
					xoff = p.x;
					yoff = p.y;
					angle = (p.a + (p.a >= 0 ? 0 : 360)) * Math.PI / 180;
					this.myobj.ctx.translate(xoff, yoff);
					this.myobj.ctx.rotate(angle);
					this.myobj.ctx.scale((!p.f ? 1 : -1), (!p.m ? 1 : -1));
					this.myobj.ctx.translate(-xoff, -yoff);
					if (p.a == 90)
					{
						this.myobj.ctx.drawImage(img, p.ox, p.oy, p.ow, p.oh, p.x - (p.f * p.ow), p.y - p.oh + (p.m * p.oh), p.ow, p.oh);
					}
					else if (p.a == 180)
					{
						this.myobj.ctx.drawImage(img, p.ox, p.oy, p.ow, p.oh, p.x - p.ow + (p.f * p.ow), p.y - p.oh + (p.m * p.oh), p.ow, p.oh);
					}
					else if (p.a == 270)
					{
						this.myobj.ctx.drawImage(img, p.ox, p.oy, p.ow, p.oh, p.x - p.ow + (p.f * p.ow), p.y - (p.m * p.oh), p.ow, p.oh);
					}
					else
					{
						this.myobj.ctx.drawImage(img, p.ox, p.oy, p.ow, p.oh, p.x - (p.f * p.ow), p.y - (p.m * p.oh), p.ow, p.oh);
					}
					this.myobj.ctx.restore();
				}
				else
				{
					this.myobj.ctx.drawImage(img, p.ox, p.oy, p.ow, p.oh, p.x, p.y, p.w, p.h);
				}

				this.myobj.ctx.lineWidth = this.myobj.bw * 2;

				if (!this.myobj.progress && i == this.myobj.cur)
				{
					if ((!p.f && p.m) || (p.f && !p.m))
					{
						this.myobj.ctx.fillStyle = "rgba(" + this.myobj.dbc + "," + this.myobj.bo + ")";
						this.myobj.ctx.fillRect(p.x, p.y, p.w, p.h);
					}
					if ((p.f && p.m && p.a == 180) || (!p.f && !p.m && p.a == 0))
					{
						if (p.x <= (p.ox + this.myobj.xo + this.myobj.sv) && p.x >= (p.ox + this.myobj.xo - this.myobj.sv) && p.y <= (p.oy + this.myobj.yo + this.myobj.sv) && p.y >= (p.oy + this.myobj.yo - this.myobj.sv))
						{
							this.myobj.ctx.strokeStyle = "rgba(" + this.myobj.dmc + ",1)";
						}
						else
						{
							this.myobj.ctx.strokeStyle = "rgba(" + this.myobj.dfc + ",1)";
						}
					}
					else
					{
						this.myobj.ctx.strokeStyle = "rgba(" + this.myobj.dfc + ",1)";
					}
					if (this.myobj.ply)
					{
						if (this.myobj.wk4 || this.myobj.ge8)
						{
							this.myobj.ctx.beginPath();
							this.myobj.ctx.moveTo(p.x + p.t[0][0], p.y + p.t[0][1]);
							for (j = 1; j < p.t.length; j++)
							{
								this.myobj.ctx.lineTo(p.x + p.t[j][0], p.y + p.t[j][1]);
							}
							this.myobj.ctx.closePath();
						}
						this.myobj.ctx.stroke();
					}
					else
					{
						this.myobj.ctx.strokeRect(p.x, p.y, p.w, p.h);
					}
				}
				else
				{
					if (this.myobj.ply)
					{
						if ((!p.f && p.m) || (p.f && !p.m))
						{

							this.myobj.ctx.fillStyle = "rgba(" + this.myobj.dbc + "," + this.myobj.bo + ")";
							this.myobj.ctx.fillRect(p.x, p.y, p.w, p.h);
							this.myobj.ctx.strokeStyle = "rgba(" + this.myobj.dbc + ",1)";
							if (this.myobj.wk4 || this.myobj.ge8)
							{
								this.myobj.ctx.beginPath();
								this.myobj.ctx.moveTo(p.x + p.t[0][0], p.y + p.t[0][1]);
								for (j = 1; j < p.t.length; j++)
								{
									this.myobj.ctx.lineTo(p.x + p.t[j][0], p.y + p.t[j][1]);
								}
								this.myobj.ctx.closePath();
							}
							this.myobj.ctx.stroke();
						}
						else
						{

							for (j = 0; j < p.t.length; j++)
							{
								c = p.l[j];
								k = j < p.t.length - 1 ? j + 1 : 0;
								this.myobj.ctx.strokeStyle = "rgba(" + c + "," + c + "," + c + "," + this.myobj.bo + ")";
								this.myobj.ctx.beginPath();
								this.myobj.ctx.moveTo(p.x + p.t[j][0], p.y + p.t[j][1]);
								this.myobj.ctx.lineTo(p.x + p.t[k][0], p.y + p.t[k][1]);
								this.myobj.ctx.stroke();
							}
						}
					}
					else
					{
						if ((!p.f && p.m) || (p.f && !p.m))
						{
							this.myobj.ctx.fillStyle = "rgba(" + this.myobj.dbc + "," + this.myobj.bo + ")";
							this.myobj.ctx.fillRect(p.x, p.y, p.w, p.h);
							this.myobj.ctx.strokeStyle = "rgba(" + this.myobj.dbc + ",1)";
							this.myobj.ctx.strokeRect(p.x, p.y, p.w, p.h);
						}
						else
						{
							this.myobj.ctx.strokeStyle = "rgba(0,0,0," + this.myobj.bo + ")";
							this.myobj.ctx.strokeRect(p.x - this.myobj.bw, p.y - this.myobj.bw, p.w + this.myobj.bw, p.h + this.myobj.bw);
							this.myobj.ctx.strokeStyle = "rgba(255,255,255," + this.myobj.bo + ")";
							this.myobj.ctx.strokeRect(p.x, p.y, p.w + this.myobj.bw, p.h + this.myobj.bw);
						}
					}
				}
				this.myobj.ctx.restore();
			}
			this.myobj.ctx.restore();
		}
		return false;
	}
	this._catchTouch = function (e)
	{
		if (this.obj && e.touches.length == 1 && !this.progress)
		{
			e.preventDefault();
			this.cur = -1;
			function last(a, i)
			{
				var t = a[i];
				a.splice(i, 1);
				a.push(t);
				return a;
			};
			this.dragging = false;
			this.currtap = new Date().getTime();
			this.evtX = e.touches[0].pageX - this.offsetX;
			this.evtY = e.touches[0].pageY - this.offsetY;
			this.cur = puzzle._isContained();
			if (this.currtap - this.lasttap < 250)
			{
				this.lasttap = -1;
				if (this.cur > -1)
				{
					var r = 90, p = this.obj[this.cur];
					if (p.f && !p.m)
					{
						if (this.ply)
						{
							this.obj[this.cur].l = puzzle._shade(this.obj[this.cur].t, this.lsd, this.nhc);
						}
						if (p.a == 90 || p.a == 270)
						{
							this.obj[this.cur].m = p.m ? 0 : 1;
						}
						else
						{
							this.obj[this.cur].f = p.f ? 0 : 1;
						}
					}
					else if (!p.f && p.m)
					{
						if (this.ply)
						{
							this.obj[this.cur].l = puzzle._shade(this.obj[this.cur].t, this.lsd, this.nhc);
						}
						if (p.a == 90 || p.a == 270)
						{
							this.obj[this.cur].f = p.f ? 0 : 1;
						}
						else
						{
							this.obj[this.cur].m = p.m ? 0 : 1;
						}
					}
					else
					{
						this.obj[this.cur] = puzzle._rotate(p, this.width, this.height, r, this.ply, this.lsd, this.nhc);
						this.obj[this.cur].a = p.a < (360 - r) ? p.a + r : 0;
					}
					puzzle._isCatched(this.cur);
					this.cur = -1;
					puzzle._paint();
					puzzle._ifSolved();
				}
			}
			else
			{
				this.lasttap = this.currtap;
				if (this.cur > -1)
				{
					if (this.cur != this.obj.length - 1)
					{
						this.obj = last(this.obj, this.cur);
						this.cur = this.obj.length - 1;
					}
					this.deltaX = this.evtX - this.obj[this.cur].x;
					this.deltaY = this.evtY - this.obj[this.cur].y;
					this.ontouchmove = puzzle._touchMove;
					this.ontouchend = puzzle._touchEnd;
					this.dragging = true;
				}
			}
		}
		return false;
	}
	this._touchMove = function (e)
	{
		if (e.touches.length == 1 && this.dragging && !this.progress)
		{
			this.evtX = e.touches[0].pageX - this.offsetX;
			this.evtY = e.touches[0].pageY - this.offsetY;
			this.obj[this.cur].x = Math.min(this.width - this.obj[this.cur].w, Math.max(0, this.evtX - this.deltaX));
			this.obj[this.cur].y = Math.min(this.height - this.obj[this.cur].h, Math.max(0, this.evtY - this.deltaY));
			puzzle._paint();
		}
		return false;
	}
	this._touchEnd = function ()
	{
		if (this.progress)
		{
			return false;
		}
		if (this.dragging && !this.progress)
		{
			this.ontouchmove = null;
			this.ontouchend = null;
			this.dragging = false;
			puzzle._isCatched(this.cur);
			this.cur = -1;
			puzzle._paint();
			puzzle._ifSolved();
		}
		return false;
	}
	this._isPressed = function (e)
	{
		if (this.progress)
		{
			return false;
		}
		function last(a, i)
		{
			var t = a[i];
			a.splice(i, 1);
			a.push(t);
			return a;
		};
		if (this.obj)
		{
			this.evtX = e.pageX - this.offsetX;
			this.evtY = e.pageY - this.offsetY;
			this.cur = puzzle._isContained();
			if (this.cur > -1)
			{
				var p = this.obj[this.cur];
				if (this.cur != this.obj.length - 1)
				{
					this.obj = last(this.obj, this.cur);
					this.cur = this.obj.length - 1;
				}
				if (e.which == 2)
				{
					if (this.ply)
					{
						this.obj[this.cur].l = puzzle._shade(this.obj[this.cur].t, this.lsd, this.nhc);
					}
					if (p.a == 90 || p.a == 270)
					{
						this.obj[this.cur].m = p.m ? 0 : 1;
					}
					else
					{
						this.obj[this.cur].f = p.f ? 0 : 1;
					}
					puzzle._isCatched(this.cur);
					this.cur = -1;
				}
				else if (e.which == 3)
				{
					if (this.ply)
					{
						this.obj[this.cur].l = puzzle._shade(this.obj[this.cur].t, this.lsd, this.nhc);
					}
					if (p.a == 90 || p.a == 270)
					{
						this.obj[this.cur].f = p.f ? 0 : 1;
					}
					else
					{
						this.obj[this.cur].m = p.m ? 0 : 1;
					}
					puzzle._isCatched(this.cur);
					this.cur = -1;
				}
				else
				{
					this.dragging = true;
					this.style.cursor = 'move';
					this.deltaX = this.evtX - this.obj[this.cur].x;
					this.deltaY = this.evtY - this.obj[this.cur].y;
				}
				puzzle._paint();
			}
		}

		this.moved = false;

		return false;
	}
	this._isDragged = function (e)
	{
		if (!this.dragging || this.progress)
		{
			return false;
		}

		this.evtX = e.pageX - this.offsetX;
		this.evtY = e.pageY - this.offsetY;
		this.obj[this.cur].x = Math.min(this.width - this.obj[this.cur].w, Math.max(0, this.evtX - this.deltaX));
		this.obj[this.cur].y = Math.min(this.height - this.obj[this.cur].h, Math.max(0, this.evtY - this.deltaY));
		puzzle._paint();

		this.moved = true;

		return false;
	}
	this._isReleased = function (e)
	{
		if (!this.dragging || this.progress)
		{
			return false;
		}
		this.dragging = false;
		puzzle._isCatched(this.cur);
		this.style.cursor = 'auto';
		this.cur = -1;

		puzzle._paint();

		puzzle._ifSolved();
		return false;
	}
	this._isDblclicked = function (e)
	{
		if (this.moved)
		{
			return false;
		}

		var shift = e.shiftKey, alt = e.altKey;
		this.dragging = false;
		this.style.cursor = 'auto';
		this.cur = -1;
		if (this.obj)
		{
			this.cur = puzzle._isContained();
			if (this.cur > -1)
			{
				var r = 90, p = this.obj[this.cur];
				if (!shift && !alt)
				{
					this.obj[this.cur] = puzzle._rotate(p, this.width, this.height, r, this.ply, this.lsd, this.nhc);
					this.obj[this.cur].a = p.a < (360 - r) ? p.a + r : 0;
					puzzle._isCatched(this.cur);
					this.cur = -1;
				}
				else if (shift && !alt)
				{
					if (this.ply)
					{
						this.obj[this.cur].l = puzzle._shade(this.obj[this.cur].t, this.lsd, this.nhc);
					}
					if (p.a == 90 || p.a == 270)
					{
						this.obj[this.cur].m = p.m ? 0 : 1;
					}
					else
					{
						this.obj[this.cur].f = p.f ? 0 : 1;
					}
					puzzle._isCatched(this.cur);
					this.cur = -1;
				}
				else if (!shift && alt)
				{
					if (this.ply)
					{
						this.obj[this.cur].l = puzzle._shade(this.obj[this.cur].t, this.lsd, this.nhc);
					}
					if (p.a == 90 || p.a == 270)
					{
						this.obj[this.cur].f = p.f ? 0 : 1;
					}
					else
					{
						this.obj[this.cur].m = p.m ? 0 : 1;
					}
					puzzle._isCatched(this.cur);
					this.cur = -1;
				}

				puzzle._paint();
				puzzle._ifSolved();
			}
		}
		return false;
	}
	this._catchOver = function (e)
	{
		cvi_stactive = this.id;
		this.focus();
		return false;
	}
	this._catchOut = function (e)
	{
		cvi_stactive = null;
		return false;
	}
	this._catchEnter = function (e)
	{
		cvi_stactive = this.id;
		this.focus();
		return false;
	}
	this._catchLeave = function (e)
	{
		cvi_stactive = null;
		return false;
	}
	this._ifSolved = function ()
	{
		if (!this.myobj.dragging || !this.myobj.progress)
		{
			if (puzzle._isSolved() && this.myobj.cb)
			{
				var timeDiff = null;
				if (this.timeFrom != null)
				{
					this.timeTo = new Date();
					timeDiff = ((this.timeTo - this.timeFrom) / 1000).toFixed(0);
				}

				this.myobj.cb(timeDiff);
			}
		}
		return false;
	}
	this._isSolved = function ()
	{
		for (var i = 0; i < this.myobj.obj.length; i++)
		{
			if (!this.myobj.obj[i].z)
			{
				return false;
			}
		}
		return true;
	}
	this._isContained = function ()
	{
		var i, j, k, c, p, l, t, x = this.myobj.evtX, y = this.myobj.evtY;
		for (i = this.myobj.obj.length - 1; i > -1; i--)
		{
			j = 0;
			k = 0;
			c = 0;
			p = this.myobj.obj[i].t;
			l = this.myobj.obj[i].x;
			t = this.myobj.obj[i].y;
			for (k in p)
			{
				j++;
				if (j == p.length)
				{
					j = 0;
				}
				if ((((t + p[k][1]) < y) && ((t + p[j][1]) >= y)) || (((t + p[j][1]) < y) && ((t + p[k][1]) >= y)))
				{
					if ((l + p[k][0]) + (y - (t + p[k][1])) / ((t + p[j][1]) - (t + p[k][1])) * ((l + p[j][0]) - (l + p[k][0])) < x)
					{
						c = !c;
					}
				}
			}
			if (c)
			{
				return i;
			}
		}
		return -1;
	}
	this._isCatched = function (cur)
	{
		var p = this.myobj.obj[cur];
		if ((p.f && p.m && p.a == 180) || (!p.f && !p.m && p.a == 0))
		{
			if (p.x <= (p.ox + this.myobj.xo + this.myobj.sv) && p.x >= (p.ox + this.myobj.xo - this.myobj.sv) && p.y <= (p.oy + this.myobj.yo + this.myobj.sv) && p.y >= (p.oy + this.myobj.yo - this.myobj.sv))
			{
				try
				{
					if (this.myobj.rpcb)
					{
						this.myobj.rpcb();
					}
				}
				catch (e) { }

				this.myobj.obj[cur].x = p.ox + this.myobj.xo;
				this.myobj.obj[cur].y = p.oy + this.myobj.yo;
				this.myobj.obj[cur].z = true;
				return true;
			}
		}
		this.myobj.obj[cur].z = false;
		return false;
	}
	this._rotate = function (p, w, h, r, z, d, k)
	{
		function sdx(v, z)
		{
			return v[0] - z[0];
		};
		function sdy(v, z)
		{
			return v[1] - z[1];
		};
		var j, x, y, px, py, mx = 0, my = 0, mw = 1, mh = 1, a = [], b = [], xo = p.x + (.5 * p.w), yo = p.y + (.5 * p.h), g = r * (Math.PI / 180), cs = Math.cos(g), sn = Math.sin(g);
		for (j = 0; j < p.t.length; j++)
		{
			px = p.x + p.t[j][0];
			py = p.y + p.t[j][1];
			x = (px - xo) * cs - (py - yo) * sn + xo;
			y = (py - yo) * cs + (px - xo) * sn + yo;
			a[j] = [x, y];
		}
		b = a.slice();
		b.sort(sdx);
		mx = b[0][0];
		mw = b[b.length - 1][0];
		b.sort(sdy);
		my = b[0][1];
		mh = b[b.length - 1][1];
		p.w = mw - mx;
		p.h = mh - my;
		p.x = mx;
		p.y = my;
		for (j = 0; j < a.length; j++)
		{
			a[j][0] = a[j][0] - p.x;
			a[j][1] = a[j][1] - p.y;
		}
		p.x = Math.max(Math.min(w - p.w, p.x), 0);
		p.y = Math.max(Math.min(h - p.h, p.y), 0);
		p.t = a;
		if (z)
		{
			p.l = puzzle._shade(a, d, k);
		}
		return p;
	}
	this._shade = function (t, d, k)
	{
		k = k || 0;
		var i, ag, ad, at, av, dx, sx, ex, dy, sy, ey, ls = (d - 180) * (Math.PI / 180), z = [];
		function fabs(n)
		{
			if (n >= 0)
			{
				return n;
			}
			else
			{
				return 0 - n;
			}
		};
		function theta(x, y)
		{
			var a = Math.atan2(y, x);
			if (a < 0.0)
			{
				a = 2 * Math.PI + a;
			}
			return a;
		};
		for (i = 0; i < t.length; i++)
		{
			sx = t[i][0];
			sy = t[i][1];
			if (i < t.length - 1)
			{
				ex = t[i + 1][0];
				ey = t[i + 1][1];
			}
			else
			{
				ex = t[0][0];
				ey = t[0][1];
			}
			dy = (ey - sy);
			dx = (sx - ex);
			ag = 2 * Math.PI - theta(dx, dy);
			ad = fabs(ls - ag);
			at = 0.5 * (Math.cos(ad) + 1.0);
			av = parseInt(at * 0 + (1.0 - at) * 255);
			z[i] = !k ? av > 127 ? 255 : 0 : av;
		}
		return z;
	}
	this._xoff = function (n)
	{
		var r = n.offsetLeft;
		for (var p = n; p = p.offsetParent; p != null)
		{
			r += p.offsetLeft;
		}
		return r;
	}
	this._yoff = function (n)
	{
		var r = n.offsetTop;
		for (var p = n; p = p.offsetParent; p != null)
		{
			r += p.offsetTop;
		}
		return r;
	}
}	